import java.awt.*;
import java.io.*;

import java.net.*;
import javax.sound.midi.*;

//import javax.swing.*;

/**
 * MIDI
 * <pre>
 * MIDIt𐧌䂵܂B
 * </pre>
 */
public class KSoundMidi {

	// MIDIV[PT
	private Sequencer sequencer;

	/**
	 * RXgN^
	 * <pre>
	 * MidiIuWFNg𐶐܂B
	 * </pre>
	 * @param obj pX߂IuWFNg
	 * @param fileName t@C
	 * @param flgLoop trueFJԂ ^ falseFJԂȂ
	 */
	public KSoundMidi(Object obj, String fileName, boolean flgLoop){

		try{

			if(obj == null){
				obj = this;
			}

			// Xg[擾
			InputStream is = obj.getClass().getResourceAsStream(fileName);

			// MIDIV[PX擾
			Sequence s = MidiSystem.getSequence(new BufferedInputStream(is));

			// MIDIV[PT擾
			this.sequencer = MidiSystem.getSequencer();

			// JԂꍇA
			if(flgLoop){
				// Ɍp
				this.sequencer.setLoopCount(Sequencer.LOOP_CONTINUOUSLY);
			}

			// J
			this.sequencer.open();
			// V[PXݒ
			this.sequencer.setSequence(s);

		}catch(InvalidMidiDataException ex){
			ex.printStackTrace();
			return;
		}catch(MidiUnavailableException ex){
			ex.printStackTrace();
			return;
		}catch(IOException ex){
			ex.printStackTrace();
			return;
		}

	} // end KSoundMidi

	/**
	 * tX^[g
	 */
	public void start(){

		// Đ
		sequencer.start();

	}

	/**
	 * tXgbv
	 */
	public void stop(){

		// s̏ꍇA
		if(sequencer.isRunning()){
			// ~
			sequencer.stop();
		}

	}

	/**
	 * tʒu
	 */
	public void init(){
		sequencer.setTickPosition(0l);
	}

	/**
	 * tǂԂ܂
	 * <pre>
	 * start()  stop() Ăяo܂ł̊ԁAtrue Ԃ܂B
	 * </pre>
	 */
	public boolean isRunning(){
		return sequencer.isRunning();
	}

}

